#include "widgetbase.h"

using namespace Janus;
  
WidgetBase::WidgetBase(const Parameters& param):
  ElementGtk(param),
  widget_(NULL),
  container_(NULL)
{
  WidgetBase *parent = dynamic_cast<WidgetBase*>(param.parent);
  if(parent)
    parent_ = parent->container_;
  else
    parent_ = NULL;  
  
  x_ = Element::getIntAttr("x",0);
  y_ = Element::getIntAttr("y",0);
  width_ = Element::getIntAttr("width",75);
  height_ = Element::getIntAttr("height",25);    
}

WidgetBase::~WidgetBase()
{
}

void 
WidgetBase::call(const std::string& name, const Value& val)
{
  if(name == "show")
    {
      gtk_widget_show(widget_);
    }
  else if(name == "hide")
    {
      gtk_widget_hide(widget_);
    }
  else if(name == "enable")
    {
      //    widget->enable();
    }
  else if(name == "disable")
    {
      // widget->disable();
    }
  else
    {
      ElementGtk::call(name, val);
    }
}
  

  

