#include "dialog.h"


using namespace Janus;

Dialog::Dialog(const Parameters& param) :
  WidgetBase(param),
  accepted_(false)
{
  //create a modal dialog !
  widget_ = new uta::Dialog(rect_.upperLeft().x, rect_.upperLeft().y,
			    rect_.width(), rect_.height(), true);

  assert(widget_); 
  widget_->setAutoDelete(false);
  widget_->setColor(color_);
  if(Element::hasAttr("background"))
    widget_->setBackground(background_);
}
  

Value 
Dialog::getValue(void) const
{
  return accepted_ ? "1" : "0";
}

void 
Dialog::call(const std::string& name, const Value& val)
{
  // dynamic_cast<uta::Dialog*> returns non-valid pointers !!!
  uta::Dialog* dialog = (uta::Dialog*)widget_;

  if(name == "execute")
    {
#ifndef NDEBUG	    
      std::cerr << "Janus::uta::call() executing uta::Dialog ... " << std::endl;
#endif      
      accepted_ = false;
      dialog->exec();
#ifndef NDEBUG	    
      std::cerr << "Janus::uta::call() returned from uta::Dialog::exec(). Yuppee !" << std::endl;
#endif      
    }
  else if(name == "accept")
    {
#ifndef NDEBUG	    
      std::cerr << "Janus::uta::Dialog::accept() " << std::endl;
#endif      
      accepted_ = true;
      dialog->accept();
    }
  else if(name == "reject")
    {
#ifndef NDEBUG	    
      std::cerr << "Janus::uta::Dialog::reject() " << std::endl;
#endif      
      dialog->reject();
    }
  else
    {
      WidgetBase::call(name, val);
    }
}
  

