#include "toolkit.h"

#include <uta/resources.h>

using namespace Janus;

Toolkit::Toolkit(const Parameters& param):
  ElementSigC(param),
  result_(0)
{
  app_ = new uta::Application(0, NULL);

  app_->init(Element::getIntAttr("width",640),
	    Element::getIntAttr("height",480),
	    Element::getIntAttr("bpp",0));

  std::string title = Element::getAttr("title","Janus libuta-Binding");
  app_->rootWindow()->setTitle(title.c_str());

  REG_FONT_RES("text_font","arial.ttf, 12, 0x101010, 0xF0F0F0");
  REG_FONT_RES("button_font","arial.ttf, 12, 0x101010, 0xF0F0F0");
                                                                              
}

Toolkit::~Toolkit()
{
  delete app_;
}

Value 
Toolkit::getValue(void) const
{
  char buffer[32];
  sprintf(buffer,"%d",result_);

  return std::string(buffer);
}

void 
Toolkit::call(const std::string& name, const Value& val)
{
  if(name == "execute")
    {
      result_ = app_->exec();
    }
  else if(name == "quit")
    {
      app_->quit();
    }
}
 

