#include "connection.h"

#include <iostream>

using namespace Janus;

// static member ...
Factory<Connection> *Connection::factory_ = NULL;

Connection::~Connection()
{

}

void
Connection::registerFactory(const std::string& type,
				   Janus::Factory<Connection>* factory)
{
#ifndef NDEBUG
  std::cerr << "Janus::Connection: registered connection factory for type " 
            << "\"" << type << "\"" << std::endl;
#endif  

  if(factory_)
    delete factory_;
  factory_ = factory;
}

void
Connection::cleanup()
{
}

Connection* 
Connection::createConnection(const Connection::Parameters& param)
{
  Connection* connection = NULL;

  if(factory_)
    {
#ifndef NDEBUG
      std::cerr << "Janus::Connection: creating new connection." << std::endl;
#endif
      connection = factory_->New(param);
    }

  return connection;
}
